﻿using System;
using System.Collections;
using UnityEngine;

namespace vamtaco
{
	public class Strapon : MVRScript
	{
		JSONStorableBool _enabled;
        Atom _dildo;

        private readonly string ParentLinkAtomStorableName = "pelvis";
        private readonly string DefaultClothingItemId = "Heat Up Panty";


        public override void Init()
		{
            if (containingAtom.type != "Person")
            {
                SuperController.LogMessage("Strapon Plugin (Disabled): This plugin is designed to be used on a person atom.");
                enabled = false;
                return;
            }

            _enabled = new JSONStorableBool("Enabled", true);
			CreateToggle(_enabled, true);

            base.StartCoroutine(CreateAtom("Dildo", "Dildo", newAtom =>
            {
                newAtom.collisionEnabledJSON.SetVal(false);
                JSONStorable storable = this.containingAtom.GetStorableByID(ParentLinkAtomStorableName);
                newAtom.mainController.transform.Rotate(new Vector3(15f, 0, 0));
                parentLinkAtPosition(newAtom, this.containingAtom, storable, ParentLinkAtomStorableName, new Vector3(0, -0.15f, 0.05f));
                newAtom.GetStorableByID("scale").SetFloatParamValue("scale", 1.0f);
                newAtom.collisionEnabledJSON.SetVal(true);
                _dildo = newAtom;
            }));

            var geometry = containingAtom.GetStorableByID("geometry");
            var character = geometry as DAZCharacterSelector;

            //if user has AmineKunai's Strapon content, load it.
            if (MVR.FileManagementSecure.FileManagerSecure.FileExists($"AddonPackages/AmineKunai.Belt_Strapon.1.var"))
            {
                var clothingItem = character.GetClothingItem("AmineKunai.Belt_Strapon.1:/Custom/Clothing/Female/AmineKunai/Amine Belt Strapon/Amine Belt Strapon.vam");
                character.ToggleClothingItem(clothingItem);
            }
            else
            {
                //load standard thong.
                var clothingItem = character.GetClothingItem(DefaultClothingItemId);
                if(!clothingItem.isActiveAndEnabled)
                    character.ToggleClothingItem(clothingItem);
            }
        }

        protected virtual IEnumerator CreateAtom(string atomType, string atomId, Action<Atom> onAtomCreated)
        {
            Atom atom = SuperController.singleton.GetAtomByUid(atomId);
            if (atom == null)
            {
                yield return SuperController.singleton.AddAtomByType(atomType, atomId);
                atom = SuperController.singleton.GetAtomByUid(atomId);
            }
            if (atom != null)
            {
                onAtomCreated(atom);
            }
        }

        public void matchRotation(Atom a, JSONStorable toRotation)
        {
            Quaternion r = toRotation.transform.rotation;
            a.mainController.currentRotationState = FreeControllerV3.RotationState.On;
            a.mainController.transform.rotation = r;
            a.mainController.transform.Rotate(0, 180, 0);
            a.mainController.currentRotationState = FreeControllerV3.RotationState.ParentLink;
        }

        public void parentLinkAtPosition(Atom a, Atom parent, JSONStorable toPosition, string toPositionName, Vector3 positionOffset = new Vector3())
        {
            a.parentAtom = parent;
            Vector3 p = toPosition.transform.position;
            a.mainController.currentPositionState = FreeControllerV3.PositionState.On;
            a.mainController.transform.position = new Vector3(p.x + positionOffset.x, p.y + positionOffset.y, p.z + positionOffset.z);

            a.mainController.SetLinkToAtom(parent.uid);
            a.mainController.SetLinkToRigidbodyObject(toPositionName);

            a.mainController.currentPositionState = FreeControllerV3.PositionState.ParentLink;
            a.mainController.currentRotationState = FreeControllerV3.RotationState.ParentLink;

            a.mainController.canGrabPosition = false;
            a.mainController.canGrabRotation = false;
        }
    }
}
